# Overview

The purpose of this plugin is to expand rundown developer's capabilities, for users they simply have to install this plugin when a custom rundown requires it.

# Features

- Anti-grief methods
- Bio Tracker
- Difficulty Scale
- Elevator Cargo
- Foam Launcher
- Gamer Glowstick
- Hack Door Puzzle
- Hammer
- Mine
- NavMesh
- Objective Modifier
- Expedition Result Page
- Player Modifier
- Resource Pack
- Rundown Layout
- Minor UI changes

# Usage for Players

Install Tweaker and a custom rundown that depends on it, and if you want to play the base game levels with it you can download the Vanilla release here on the thunderstore. There are also some client side settings in the configs for you to use as well.

# Usage for Rundown developers

1. Run the game once to generate a custom folder with Tweaker json files in the datablock folder
2. Modify the Tweaker files, don't forget to set `internalEnabled` to `true` as it generates with `false` by default and other enable flags as well
3. Restart the game to test the settings

# Note
If something is enabled in the configs it will enable a patch for the game, which may cause unintented side effects even if you're using the default settings for the config

## BioTracker
More settings for the BioTracker. Max objects is hard limited to 20. Set up custom item/playeroffline blocks and make a copy of the settings to have multiple BioTrackers.

## Difficulty Scale
No per expedition setting yet, dynamically adjusts the difficulty depending on how many players are in your expedition. Solo is one player, Duo is two, Trio is three, Full is four players. Set enable to true for the party size and a value for the desired parameter to something other than 1 to have it take effect.

## Elevator Cargo
`DataBlockId` is the warden objective ID (I recommend using your high objective) and the ItemID can be anything in the item datablock except for gear. More than one item id can be specified as well as different ones to get a mixed cargo. ForceDisable will prevent usage of the elevator cargo entirely. More than one cargo setting can be used as well if you copy the default given and make a new entry in the array.

## Foam Launcher
More settings for the c-foam launcher. burstShots min and max do not accept decimal values. Set up custom item/playeroffline blocks and make a copy of the settings to have multiple Foam Launchers.

## Gamer Glowstick
No multiple item settings yeet, use a glowstick in the item datablock. pulserate is how quickly the glowstick will change colors while max and min are the range at which the colors will change.

## Hack Door puzzle
This uses the chained puzzle id and if the zone door in a level has the same one it will apply a hack lock to it. Upon failing it will spawn a scout wave. `SetInteractionMessage` will replace the text prompt for the door with a generic one.

## Hammer
There are too many settings for the hammer to explain, but it works like an array so you can have multiple settings for different hammers. Use the item datablock id to tie them to it

## Mine
Allows for multiple item set up, `DeployPickupInteractionDuration` and `TimeBetweenPlacements` only affect the mine deployer; everything else is applied to the mines set (can even affect consumables if set up correctly).

## Nav Mesh
No per expedition setting yet, determines how enemies can move around in the level and avoid each other (doesn't affect their actual collision). The default agent radius of 0.25f is too small and I suggest 0.375f or 0.35f. It's better to have a higher agent radius, but if you run into issues where enemies get stuck in the level you can set it lower. You can edit the bepinex config setting to enable use of a mesh visualizer for debug purposes, handy to see where your enemies are getting stuck. It defaults to F11 to show the mesh, Page up/Page down to move it vertically and End to reset the position.

## Objective Modifier
Specify the High warden objective id and when the time runs out the player can either explode or continuously get infected. Player explosion will take priority over the infection when both are enabled.

## Expedition Result Page
Affects every expedition result screen text when enabled

## Player Modifier
No per expedition setting yet, can change slide force, evasion speed, model scale and b-hop alerting

## Resource pack
Specify the high warden objective and you can adjust how much each pack gives a player, you can have different settings per expedition. Known issue: when reducing the amount of tool (class ammo) given to mines it can not always give the player a mine. This is more of an issue with base game than my plugin.

## Rundown Layout
`Decrypt` accepts a string input and will show text above a button, `Label` will replace the text of the button itself, `Heat` will determine if you want to show the artifact heat for an expedition, `Status` will replace the 'not completed' or expedition progression text beneath your button with a custom string, `Scale` is calculated based on the inverse of scale given in the rundown datablock `1/scale`, `Position` x is left and right, y is forward and backward, z is up and down, `HideProgression` will hide the expedition progression icons on the top right, `HideTiers` will hide the tier labels on the right